----------------------------------------------------------------------------------
-- Company:             www.kampis-elektroecke.de
-- Engineer:            Daniel Kampert
-- 
-- Create Date:         05.03.2015 13:21:32
-- Design Name: 
-- Module Name:         Top - Top_Arch
-- Project Name: 
-- Target Devices:      XC7Z010CLG400-1
-- Tool Versions:       Vivado 2014.4
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Top is
    Port (  RGB         : out STD_LOGIC_VECTOR(15 downto 0);
            Input       : in STD_LOGIC_VECTOR(3 downto 0);
            HSync       : out STD_LOGIC;
            VSync       : out STD_LOGIC;
            Reset       : in STD_LOGIC;
            Clock_In    : in STD_LOGIC;    
            Output      : out STD_LOGIC_VECTOR(1 downto 0)
            );
end Top;

architecture Top_Arch of Top is

    -- Clocksignale
    signal Clock_VGA    : std_logic;
    
    -- Systemsignale
    signal Clock_Lock : std_logic;
    
    -- Testsignale
    signal Farbe    : std_logic_vector(15 downto 0) := x"FFFF";
    
    -- Erzeugung des 25,175MHz Taktes
    component Clock is
        Port (  Clock_In    : in STD_LOGIC;
                Clock_Locked: out STD_LOGIC;
                Clock_Out   : out STD_LOGIC;
                Clock_Reset : in STD_LOGIC
                );
    end component Clock;
    
    component VGA is
        Generic (
                Color_Width         : integer := 16;
                ROM_Address_Width   : integer := 11;
                ROM_Data_Width      : integer := 8;
                Char_Size           : integer := 8
                );
        Port (  Clock_VGA   : in STD_LOGIC;
                Reset       : in STD_LOGIC;
                Mode        : in STD_LOGIC;
                Color       : in STD_LOGIC_VECTOR(15 downto 0);
                HSync       : out STD_LOGIC;
                VSync       : out STD_LOGIC;
                RGB         : out STD_LOGIC_VECTOR((Color_Width - 1) downto 0) 
                );
    end component VGA;

begin

    Clock_25MHz     : Clock port map (Clock_In, Clock_Lock, Clock_VGA, Reset);
    VGA_Top         : VGA port map (Clock_VGA, Reset, '1', Farbe, HSync, VSync, RGB);

    -- Betriebsstatus
    Output(0) <= not Reset;
    Output(1) <= Clock_Lock;

end Top_Arch;